From ae7692214376ee0f01d52be3ac1000579a540efa Mon Sep 17 00:00:00 2001
From: Akashdeep Dhar <t0xic0der@fedoraproject.org>
Date: Apr 06 2021 12:35:59 +0000
Subject: [PATCH 7/15] Relocated CSS and JS assets to a new directory


---

diff --git a/data/jscn/search.js b/data/jscn/search.js
new file mode 100644
index 0000000..17b8780
--- /dev/null
+++ b/data/jscn/search.js
@@ -0,0 +1,270 @@
+/*
+ *************************************************************************
+ *
+ * Copyright (C) 2020-2021 Mrinal Kumar <kmrinal19@gmail.com>
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <https://www.gnu.org/licenses/>.
+ *
+ *************************************************************************
+ */
+
+var prev_search_text
+var current_tab = 'WELCOME'
+var search_type = 'ISSUES'
+var fedora_issues
+var bugzilla_issues
+var fedora_projects
+var bugzilla_projects
+var fedora_tab
+var bugzilla_tab
+var issues
+var all_projects
+var search_bar
+var search_option
+var search_types
+var no_issue_element
+
+/**
+ * Initializes the global variables and add event listeners
+ */
+function init () {
+  issues = Array.prototype.slice.call(
+    document.getElementsByClassName('issueRow')
+  )
+  all_projects = Array.prototype.slice.call(
+    document.getElementsByClassName('project-container')
+  )
+  search_bar = document.getElementById('searchBar')
+  search_option = document.getElementById('search-dropdown-option')
+  no_issue_element = document.getElementById('no-issue')
+  fedora_tab = document.getElementById('doramode')
+  bugzilla_tab = document.getElementById('bugzmode')
+  fedora_issues = Array.prototype.slice.call(
+    fedora_tab.getElementsByClassName('issueRow')
+  )
+  bugzilla_issues = Array.prototype.slice.call(
+    bugzilla_tab.getElementsByClassName('issueRow')
+  )
+  fedora_projects = Array.prototype.slice.call(
+    fedora_tab.getElementsByClassName('project-container')
+  )
+  bugzilla_projects = Array.prototype.slice.call(
+    bugzilla_tab.getElementsByClassName('project-container')
+  )
+  document.getElementById('doratabe').addEventListener('click', function () {
+    resetSearch('FEDORA')
+  })
+  document.getElementById('bugztabe').addEventListener('click', function () {
+    resetSearch('BUGZILLA')
+  })
+  document.getElementById('wlcmtabe').addEventListener('click', function () {
+    resetSearch('WELCOME')
+  })
+  search_bar.addEventListener('input', search)
+  search_types = Array.prototype.slice.call(
+    search_option.getElementsByTagName('li')
+  )
+  search_types.filter(function (type) {
+    type.addEventListener('click', handleTypeChange)
+  })
+}
+
+/**
+ * FIlters all the issues and projects according to the search type.
+ */
+function search () {
+  var search_text = search_bar.value.toUpperCase()
+  // Only execute search if previous search text is not same as current search test
+  // and current tab is not the welcome tab
+  if (prev_search_text !== search_text && current_tab != 'WELCOME') {
+    prev_search_text = search_text
+    let visible_projects
+    let current_issues =
+      current_tab === 'FEDORA' ? fedora_issues : bugzilla_issues
+    let current_projects =
+      current_tab === 'FEDORA' ? fedora_projects : bugzilla_projects
+    switch (search_type) {
+      case 'ISSUES':
+        current_issues.filter(function (issue) {
+          let title = issue.getElementsByClassName('ticket_title')
+          if (title.length > 0) {
+            let issue_text = title[0].textContent.toUpperCase()
+            // Hide the issue if search text is not present in issue title
+            toggleVisibility(issue, issue_text.indexOf(search_text) > -1)
+
+            // If there are no issues in a project hide the project
+            let project = issue.closest('tBody')
+            let project_bugs_count = countVisibleBugs(project)
+            if (project_bugs_count === 0) {
+              toggleVisibility(project.closest('.project-container'), true)
+              project_bugs_count = countVisibleBugs(project)
+            }
+            toggleVisibility(
+              project.closest('.project-container'),
+              project_bugs_count !== 0
+            )
+          }
+        })
+        // Display a no issue found message if there are no projects
+        visible_projects = countVisibleProjects(current_projects)
+        toggleVisibility(no_issue_element, visible_projects === 0)
+        break
+      case 'NUMBER':
+        current_issues.filter(function (issue) {
+          let id = issue.getElementsByClassName('bug_id')
+          if (id.length > 0) {
+            let issue_id = id[0].textContent.toUpperCase()
+            // Hide the issue if search text is not present in issue number
+            toggleVisibility(issue, issue_id.indexOf(search_text) > -1)
+
+            // If there are no issues in a project hide the project
+            let project = issue.closest('tBody')
+            let project_bugs_count = countVisibleBugs(project)
+            if (project_bugs_count === 0) {
+              toggleVisibility(project.closest('.project-container'), true)
+              project_bugs_count = countVisibleBugs(project)
+            }
+            toggleVisibility(
+              project.closest('.project-container'),
+              project_bugs_count !== 0
+            )
+          }
+        })
+        // Display a no issue found message if there are no projects
+        visible_projects = countVisibleProjects(current_projects)
+        toggleVisibility(no_issue_element, visible_projects === 0)
+        break
+      case 'PROJECTS':
+        all_projects.filter(function (project) {
+          let name = project.getElementsByClassName('project_name')
+          if (name.length > 0) {
+            let project_name = name[0].textContent.toUpperCase()
+            // Hide the project if search text is not present in project name
+            toggleVisibility(project, project_name.indexOf(search_text) > -1)
+          }
+        })
+        // Display a no issue found message if there are no projects
+        visible_projects = countVisibleProjects(current_projects)
+        toggleVisibility(no_issue_element, visible_projects === 0)
+        break
+      default:
+        null
+    }
+  }
+}
+
+/**
+ * Clears all the filters and resets the search type options according to current tab
+ * @param {string} tab - Tab for which the search has to be reset
+ */
+function resetSearch (tab) {
+  search_bar.value = ''
+  all_projects.filter(function (project) {
+    toggleVisibility(project, true)
+  })
+  issues.filter(function (issue) {
+    toggleVisibility(issue, true)
+  })
+  toggleVisibility(no_issue_element, false)
+
+  // Bugzilla tab has only two search type options : ISSUES and NUMBER
+  // whereas other tabs have ISSUES, NUMBER AND PROJECTS
+  let has_project_filter = false
+  let project_filter = null
+  search_types.filter(function (type) {
+    if (type.textContent === 'PROJECTS' && type.style.display !== 'none') {
+      has_project_filter = true
+      project_filter = type
+    } else if (type.textContent === 'PROJECTS') {
+      project_filter = type
+    }
+  })
+  if (current_tab != tab) {
+    search_type = 'ISSUES'
+    current_tab = tab
+    document.getElementById('search-label').textContent = search_type
+    if (current_tab === 'BUGZILLA') {
+      if (has_project_filter && project_filter) {
+        project_filter.removeEventListener('click', handleTypeChange)
+        project_filter.style.display = 'none'
+      }
+    } else {
+      if (!has_project_filter && project_filter) {
+        project_filter.style.display = ''
+        project_filter.addEventListener('click', handleTypeChange)
+      }
+    }
+  }
+}
+
+/**
+ * Changes label for search type and resets the filters
+ */
+function handleTypeChange () {
+  if (this && this.textContent && this.textContent !== search_type) {
+    resetSearch(current_tab)
+    search_type = this.textContent
+    document.getElementById('search-label').textContent = search_type
+  }
+}
+
+/**
+ * Changes visibility of the element based on flag
+ * @param {object} element - Element whose visibility has to be changed
+ * @param {boolean} flag
+ */
+function toggleVisibility (element, flag) {
+  if (element) {
+    element.style.display = flag ? '' : 'none'
+  }
+}
+
+/**
+ * Return whether an element is visible
+ * @param {object} element - Element whose visibility has to be checked
+ * @returns {boolean}
+ */
+function isHidden (element) {
+  if (element) {
+    return (
+      element.style.display === 'none' || element.style.visibility === 'hidden'
+    )
+  }
+  return true
+}
+
+/**
+ * Return the number of remaing issues inside a project after applying the filter
+ * @param {object} project
+ * @returns {number}
+ */
+function countVisibleBugs (project) {
+  let project_bugs = Array.prototype.slice.call(project.children)
+  let visible_project_bugs = project_bugs.filter(function (bug) {
+    return !isHidden(bug)
+  })
+  return visible_project_bugs.length
+}
+
+/**
+ * Return the number of visible projects after applying the filter
+ * @param {object} projects - Array of projects
+ * @returns {number}
+ */
+function countVisibleProjects (projects) {
+  let visible_projects = projects.filter(function (project) {
+    return !isHidden(project)
+  })
+  return visible_projects.length
+}
